'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var require$$1 = require('inherits');
var cosmiconfig = require('cosmiconfig');
var jsStringEscape = require('js-string-escape');
var api = require('@structured-types/api');
var fs = require('fs');
var hostedGitInfo = require('hosted-git-info');
var require$$0 = require('punycode');
var require$$2 = require('querystring');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
	if (e && e.__esModule) return e;
	var n = Object.create(null);
	if (e) {
		Object.keys(e).forEach(function (k) {
			if (k !== 'default') {
				var d = Object.getOwnPropertyDescriptor(e, k);
				Object.defineProperty(n, k, d.get ? d : {
					enumerable: true,
					get: function () { return e[k]; }
				});
			}
		});
	}
	n["default"] = e;
	return Object.freeze(n);
}

var require$$1__default = /*#__PURE__*/_interopDefaultLegacy(require$$1);
var jsStringEscape__default = /*#__PURE__*/_interopDefaultLegacy(jsStringEscape);
var fs__namespace = /*#__PURE__*/_interopNamespace(fs);
var hostedGitInfo__default = /*#__PURE__*/_interopDefaultLegacy(hostedGitInfo);
var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0);
var require$$2__default = /*#__PURE__*/_interopDefaultLegacy(require$$2);

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

var path$1 = {exports: {}};

var util$3 = {};

var isBuffer = function isBuffer(arg) {
  return arg instanceof Buffer;
};

(function (exports) {
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(commonjsGlobal.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var length = output.reduce(function(prev, cur) {
    if (cur.indexOf('\n') >= 0) ;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = isBuffer;

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = require$$1__default["default"];

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}
}(util$3));

var isWindows = process.platform === 'win32';
var util$2 = util$3;


// resolves . and .. elements in a path array with directory names there
// must be no slashes or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  var res = [];
  for (var i = 0; i < parts.length; i++) {
    var p = parts[i];

    // ignore empty parts
    if (!p || p === '.')
      continue;

    if (p === '..') {
      if (res.length && res[res.length - 1] !== '..') {
        res.pop();
      } else if (allowAboveRoot) {
        res.push('..');
      }
    } else {
      res.push(p);
    }
  }

  return res;
}

// returns an array with empty elements removed from either end of the input
// array or the original array if no elements need to be removed
function trimArray(arr) {
  var lastIndex = arr.length - 1;
  var start = 0;
  for (; start <= lastIndex; start++) {
    if (arr[start])
      break;
  }

  var end = lastIndex;
  for (; end >= 0; end--) {
    if (arr[end])
      break;
  }

  if (start === 0 && end === lastIndex)
    return arr;
  if (start > end)
    return [];
  return arr.slice(start, end + 1);
}

// Regex to split a windows path into three parts: [*, device, slash,
// tail] windows-only
var splitDeviceRe =
    /^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/;

// Regex to split the tail part of the above into [*, dir, basename, ext]
var splitTailRe =
    /^([\s\S]*?)((?:\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))(?:[\\\/]*)$/;

var win32 = {};

// Function to split a filename into [root, dir, basename, ext]
function win32SplitPath(filename) {
  // Separate device+slash from tail
  var result = splitDeviceRe.exec(filename),
      device = (result[1] || '') + (result[2] || ''),
      tail = result[3] || '';
  // Split the tail into dir, basename and extension
  var result2 = splitTailRe.exec(tail),
      dir = result2[1],
      basename = result2[2],
      ext = result2[3];
  return [device, dir, basename, ext];
}

function win32StatPath(path) {
  var result = splitDeviceRe.exec(path),
      device = result[1] || '',
      isUnc = !!device && device[1] !== ':';
  return {
    device: device,
    isUnc: isUnc,
    isAbsolute: isUnc || !!result[2], // UNC paths are always absolute
    tail: result[3]
  };
}

function normalizeUNCRoot(device) {
  return '\\\\' + device.replace(/^[\\\/]+/, '').replace(/[\\\/]+/g, '\\');
}

// path.resolve([from ...], to)
win32.resolve = function() {
  var resolvedDevice = '',
      resolvedTail = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1; i--) {
    var path;
    if (i >= 0) {
      path = arguments[i];
    } else if (!resolvedDevice) {
      path = process.cwd();
    } else {
      // Windows has the concept of drive-specific current working
      // directories. If we've resolved a drive letter but not yet an
      // absolute path, get cwd for that drive. We're sure the device is not
      // an unc path at this points, because unc paths are always absolute.
      path = process.env['=' + resolvedDevice];
      // Verify that a drive-local cwd was found and that it actually points
      // to our drive. If not, default to the drive's root.
      if (!path || path.substr(0, 3).toLowerCase() !==
          resolvedDevice.toLowerCase() + '\\') {
        path = resolvedDevice + '\\';
      }
    }

    // Skip empty and invalid entries
    if (!util$2.isString(path)) {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    var result = win32StatPath(path),
        device = result.device,
        isUnc = result.isUnc,
        isAbsolute = result.isAbsolute,
        tail = result.tail;

    if (device &&
        resolvedDevice &&
        device.toLowerCase() !== resolvedDevice.toLowerCase()) {
      // This path points to another device so it is not applicable
      continue;
    }

    if (!resolvedDevice) {
      resolvedDevice = device;
    }
    if (!resolvedAbsolute) {
      resolvedTail = tail + '\\' + resolvedTail;
      resolvedAbsolute = isAbsolute;
    }

    if (resolvedDevice && resolvedAbsolute) {
      break;
    }
  }

  // Convert slashes to backslashes when `resolvedDevice` points to an UNC
  // root. Also squash multiple slashes into a single one where appropriate.
  if (isUnc) {
    resolvedDevice = normalizeUNCRoot(resolvedDevice);
  }

  // At this point the path should be resolved to a full absolute path,
  // but handle relative paths to be safe (might happen when process.cwd()
  // fails)

  // Normalize the tail path
  resolvedTail = normalizeArray(resolvedTail.split(/[\\\/]+/),
                                !resolvedAbsolute).join('\\');

  return (resolvedDevice + (resolvedAbsolute ? '\\' : '') + resolvedTail) ||
         '.';
};


win32.normalize = function(path) {
  var result = win32StatPath(path),
      device = result.device,
      isUnc = result.isUnc,
      isAbsolute = result.isAbsolute,
      tail = result.tail,
      trailingSlash = /[\\\/]$/.test(tail);

  // Normalize the tail path
  tail = normalizeArray(tail.split(/[\\\/]+/), !isAbsolute).join('\\');

  if (!tail && !isAbsolute) {
    tail = '.';
  }
  if (tail && trailingSlash) {
    tail += '\\';
  }

  // Convert slashes to backslashes when `device` points to an UNC root.
  // Also squash multiple slashes into a single one where appropriate.
  if (isUnc) {
    device = normalizeUNCRoot(device);
  }

  return device + (isAbsolute ? '\\' : '') + tail;
};


win32.isAbsolute = function(path) {
  return win32StatPath(path).isAbsolute;
};

win32.join = function() {
  var paths = [];
  for (var i = 0; i < arguments.length; i++) {
    var arg = arguments[i];
    if (!util$2.isString(arg)) {
      throw new TypeError('Arguments to path.join must be strings');
    }
    if (arg) {
      paths.push(arg);
    }
  }

  var joined = paths.join('\\');

  // Make sure that the joined path doesn't start with two slashes, because
  // normalize() will mistake it for an UNC path then.
  //
  // This step is skipped when it is very clear that the user actually
  // intended to point at an UNC path. This is assumed when the first
  // non-empty string arguments starts with exactly two slashes followed by
  // at least one more non-slash character.
  //
  // Note that for normalize() to treat a path as an UNC path it needs to
  // have at least 2 components, so we don't filter for that here.
  // This means that the user can use join to construct UNC paths from
  // a server name and a share name; for example:
  //   path.join('//server', 'share') -> '\\\\server\\share\')
  if (!/^[\\\/]{2}[^\\\/]/.test(paths[0])) {
    joined = joined.replace(/^[\\\/]{2,}/, '\\');
  }

  return win32.normalize(joined);
};


// path.relative(from, to)
// it will solve the relative path from 'from' to 'to', for instance:
// from = 'C:\\orandea\\test\\aaa'
// to = 'C:\\orandea\\impl\\bbb'
// The output of the function should be: '..\\..\\impl\\bbb'
win32.relative = function(from, to) {
  from = win32.resolve(from);
  to = win32.resolve(to);

  // windows is not case sensitive
  var lowerFrom = from.toLowerCase();
  var lowerTo = to.toLowerCase();

  var toParts = trimArray(to.split('\\'));

  var lowerFromParts = trimArray(lowerFrom.split('\\'));
  var lowerToParts = trimArray(lowerTo.split('\\'));

  var length = Math.min(lowerFromParts.length, lowerToParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (lowerFromParts[i] !== lowerToParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  if (samePartsLength == 0) {
    return to;
  }

  var outputParts = [];
  for (var i = samePartsLength; i < lowerFromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('\\');
};


win32._makeLong = function(path) {
  // Note: this will *probably* throw somewhere.
  if (!util$2.isString(path))
    return path;

  if (!path) {
    return '';
  }

  var resolvedPath = win32.resolve(path);

  if (/^[a-zA-Z]\:\\/.test(resolvedPath)) {
    // path is local filesystem path, which needs to be converted
    // to long UNC path.
    return '\\\\?\\' + resolvedPath;
  } else if (/^\\\\[^?.]/.test(resolvedPath)) {
    // path is network UNC path, which needs to be converted
    // to long UNC path.
    return '\\\\?\\UNC\\' + resolvedPath.substring(2);
  }

  return path;
};


win32.dirname = function(path) {
  var result = win32SplitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


win32.basename = function(path, ext) {
  var f = win32SplitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


win32.extname = function(path) {
  return win32SplitPath(path)[3];
};


win32.format = function(pathObject) {
  if (!util$2.isObject(pathObject)) {
    throw new TypeError(
        "Parameter 'pathObject' must be an object, not " + typeof pathObject
    );
  }

  var root = pathObject.root || '';

  if (!util$2.isString(root)) {
    throw new TypeError(
        "'pathObject.root' must be a string or undefined, not " +
        typeof pathObject.root
    );
  }

  var dir = pathObject.dir;
  var base = pathObject.base || '';
  if (!dir) {
    return base;
  }
  if (dir[dir.length - 1] === win32.sep) {
    return dir + base;
  }
  return dir + win32.sep + base;
};


win32.parse = function(pathString) {
  if (!util$2.isString(pathString)) {
    throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
    );
  }
  var allParts = win32SplitPath(pathString);
  if (!allParts || allParts.length !== 4) {
    throw new TypeError("Invalid path '" + pathString + "'");
  }
  return {
    root: allParts[0],
    dir: allParts[0] + allParts[1].slice(0, -1),
    base: allParts[2],
    ext: allParts[3],
    name: allParts[2].slice(0, allParts[2].length - allParts[3].length)
  };
};


win32.sep = '\\';
win32.delimiter = ';';


// Split a filename into [root, dir, basename, ext], unix version
// 'root' is just a slash, or nothing.
var splitPathRe =
    /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
var posix = {};


function posixSplitPath(filename) {
  return splitPathRe.exec(filename).slice(1);
}


// path.resolve([from ...], to)
// posix version
posix.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (!util$2.isString(path)) {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path[0] === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(resolvedPath.split('/'),
                                !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
posix.normalize = function(path) {
  var isAbsolute = posix.isAbsolute(path),
      trailingSlash = path && path[path.length - 1] === '/';

  // Normalize the path
  path = normalizeArray(path.split('/'), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
posix.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
posix.join = function() {
  var path = '';
  for (var i = 0; i < arguments.length; i++) {
    var segment = arguments[i];
    if (!util$2.isString(segment)) {
      throw new TypeError('Arguments to path.join must be strings');
    }
    if (segment) {
      if (!path) {
        path += segment;
      } else {
        path += '/' + segment;
      }
    }
  }
  return posix.normalize(path);
};


// path.relative(from, to)
// posix version
posix.relative = function(from, to) {
  from = posix.resolve(from).substr(1);
  to = posix.resolve(to).substr(1);

  var fromParts = trimArray(from.split('/'));
  var toParts = trimArray(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};


posix._makeLong = function(path) {
  return path;
};


posix.dirname = function(path) {
  var result = posixSplitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


posix.basename = function(path, ext) {
  var f = posixSplitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


posix.extname = function(path) {
  return posixSplitPath(path)[3];
};


posix.format = function(pathObject) {
  if (!util$2.isObject(pathObject)) {
    throw new TypeError(
        "Parameter 'pathObject' must be an object, not " + typeof pathObject
    );
  }

  var root = pathObject.root || '';

  if (!util$2.isString(root)) {
    throw new TypeError(
        "'pathObject.root' must be a string or undefined, not " +
        typeof pathObject.root
    );
  }

  var dir = pathObject.dir ? pathObject.dir + posix.sep : '';
  var base = pathObject.base || '';
  return dir + base;
};


posix.parse = function(pathString) {
  if (!util$2.isString(pathString)) {
    throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
    );
  }
  var allParts = posixSplitPath(pathString);
  if (!allParts || allParts.length !== 4) {
    throw new TypeError("Invalid path '" + pathString + "'");
  }
  allParts[1] = allParts[1] || '';
  allParts[2] = allParts[2] || '';
  allParts[3] = allParts[3] || '';

  return {
    root: allParts[0],
    dir: allParts[0] + allParts[1].slice(0, -1),
    base: allParts[2],
    ext: allParts[3],
    name: allParts[2].slice(0, allParts[2].length - allParts[3].length)
  };
};


posix.sep = '/';
posix.delimiter = ':';


if (isWindows)
  path$1.exports = win32;
else /* posix */
  path$1.exports = posix;

path$1.exports.posix = posix;
path$1.exports.win32 = win32;

var path = path$1.exports;

/**
 * Documentation node kinds
 */
exports.NodeKind = void 0;
(function (NodeKind) {
    NodeKind[NodeKind["Table"] = 1] = "Table";
    NodeKind[NodeKind["TableRow"] = 2] = "TableRow";
    NodeKind[NodeKind["TableCell"] = 3] = "TableCell";
    NodeKind[NodeKind["Heading"] = 4] = "Heading";
    NodeKind[NodeKind["Paragraph"] = 5] = "Paragraph";
    NodeKind[NodeKind["Text"] = 6] = "Text";
    NodeKind[NodeKind["Bold"] = 7] = "Bold";
    NodeKind[NodeKind["Emphasis"] = 8] = "Emphasis";
    NodeKind[NodeKind["Link"] = 9] = "Link";
    NodeKind[NodeKind["Code"] = 10] = "Code";
    NodeKind[NodeKind["InlineCode"] = 11] = "InlineCode";
})(exports.NodeKind || (exports.NodeKind = {}));
/**
 * Node with children type guard predicate
 */
const isNodeWithChildren = (node) => {
    return (node.kind === exports.NodeKind.Table ||
        node.kind === exports.NodeKind.TableRow ||
        node.kind === exports.NodeKind.TableCell ||
        node.kind === exports.NodeKind.Heading ||
        node.kind === exports.NodeKind.Paragraph ||
        node.kind === exports.NodeKind.Bold ||
        node.kind === exports.NodeKind.Emphasis ||
        node.kind === exports.NodeKind.Link);
};
/**
 * Node with value type guard predicate
 */
const isNodeWithValue = (node) => {
    return (node.kind === exports.NodeKind.Text ||
        node.kind === exports.NodeKind.InlineCode ||
        node.kind === exports.NodeKind.Code);
};
/**
 * TableNode type guard predicate
 */
const isTableNode = (node) => {
    return node.kind === exports.NodeKind.Table;
};
/**
 * TableRowNode type guard predicate
 */
const isTableRowNode = (node) => {
    return node.kind === exports.NodeKind.TableRow;
};
/**
 * TableCellNode type guard predicate
 */
const isTableCellNode = (node) => {
    return node.kind === exports.NodeKind.TableCell;
};
/**
 * HeadingNode type guard predicate
 */
const isHeadingNode = (node) => {
    return node.kind === exports.NodeKind.Heading;
};
/**
 * ParagraphNode type guard predicate
 */
const isParagraphNode = (node) => {
    return node.kind === exports.NodeKind.Paragraph;
};
/**
 * TextNode type guard predicate
 */
const isTextNode = (node) => {
    return node.kind === exports.NodeKind.Text;
};
/**
 * BoldNode type guard predicate
 */
const isBoldNode = (node) => {
    return node.kind === exports.NodeKind.Bold;
};
/**
 * EmphasisNode type guard predicate
 */
const isEmphasisNode = (node) => {
    return node.kind === exports.NodeKind.Emphasis;
};
/**
 * LinkNode type guard predicate
 */
const isLinkNode = (node) => {
    return node.kind === exports.NodeKind.Link;
};
/**
 * CodeNode type guard predicate
 */
const isCodeNode = (node) => {
    return node.kind === exports.NodeKind.Code;
};
/**
 * InlineCodeNode type guard predicate
 */
const isInlineCodeNode = (node) => {
    return node.kind === exports.NodeKind.InlineCode;
};

var url = {};

var util$1 = {
  isString: function(arg) {
    return typeof(arg) === 'string';
  },
  isObject: function(arg) {
    return typeof(arg) === 'object' && arg !== null;
  },
  isNull: function(arg) {
    return arg === null;
  },
  isNullOrUndefined: function(arg) {
    return arg == null;
  }
};

var punycode = require$$0__default["default"];
var util = util$1;

url.parse = urlParse;
url.resolve = urlResolve;
url.resolveObject = urlResolveObject;
url.format = urlFormat;

url.Url = Url;

function Url() {
  this.protocol = null;
  this.slashes = null;
  this.auth = null;
  this.host = null;
  this.port = null;
  this.hostname = null;
  this.hash = null;
  this.search = null;
  this.query = null;
  this.pathname = null;
  this.path = null;
  this.href = null;
}

// Reference: RFC 3986, RFC 1808, RFC 2396

// define these here so at least they only have to be
// compiled once on the first module load.
var protocolPattern = /^([a-z0-9.+-]+:)/i,
    portPattern = /:[0-9]*$/,

    // Special case for a simple path URL
    simplePathPattern = /^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,

    // RFC 2396: characters reserved for delimiting URLs.
    // We actually just auto-escape these.
    delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

    // RFC 2396: characters not allowed for various reasons.
    unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

    // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
    autoEscape = ['\''].concat(unwise),
    // Characters that are never ever allowed in a hostname.
    // Note that any invalid chars are also handled, but these
    // are the ones that are *expected* to be seen, so we fast-path
    // them.
    nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
    hostEndingChars = ['/', '?', '#'],
    hostnameMaxLen = 255,
    hostnamePartPattern = /^[+a-z0-9A-Z_-]{0,63}$/,
    hostnamePartStart = /^([+a-z0-9A-Z_-]{0,63})(.*)$/,
    // protocols that can allow "unsafe" and "unwise" chars.
    unsafeProtocol = {
      'javascript': true,
      'javascript:': true
    },
    // protocols that never have a hostname.
    hostlessProtocol = {
      'javascript': true,
      'javascript:': true
    },
    // protocols that always contain a // bit.
    slashedProtocol = {
      'http': true,
      'https': true,
      'ftp': true,
      'gopher': true,
      'file': true,
      'http:': true,
      'https:': true,
      'ftp:': true,
      'gopher:': true,
      'file:': true
    },
    querystring = require$$2__default["default"];

function urlParse(url, parseQueryString, slashesDenoteHost) {
  if (url && util.isObject(url) && url instanceof Url) return url;

  var u = new Url;
  u.parse(url, parseQueryString, slashesDenoteHost);
  return u;
}

Url.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
  if (!util.isString(url)) {
    throw new TypeError("Parameter 'url' must be a string, not " + typeof url);
  }

  // Copy chrome, IE, opera backslash-handling behavior.
  // Back slashes before the query string get converted to forward slashes
  // See: https://code.google.com/p/chromium/issues/detail?id=25916
  var queryIndex = url.indexOf('?'),
      splitter =
          (queryIndex !== -1 && queryIndex < url.indexOf('#')) ? '?' : '#',
      uSplit = url.split(splitter),
      slashRegex = /\\/g;
  uSplit[0] = uSplit[0].replace(slashRegex, '/');
  url = uSplit.join(splitter);

  var rest = url;

  // trim before proceeding.
  // This is to support parse stuff like "  http://foo.com  \n"
  rest = rest.trim();

  if (!slashesDenoteHost && url.split('#').length === 1) {
    // Try fast path regexp
    var simplePath = simplePathPattern.exec(rest);
    if (simplePath) {
      this.path = rest;
      this.href = rest;
      this.pathname = simplePath[1];
      if (simplePath[2]) {
        this.search = simplePath[2];
        if (parseQueryString) {
          this.query = querystring.parse(this.search.substr(1));
        } else {
          this.query = this.search.substr(1);
        }
      } else if (parseQueryString) {
        this.search = '';
        this.query = {};
      }
      return this;
    }
  }

  var proto = protocolPattern.exec(rest);
  if (proto) {
    proto = proto[0];
    var lowerProto = proto.toLowerCase();
    this.protocol = lowerProto;
    rest = rest.substr(proto.length);
  }

  // figure out if it's got a host
  // user@server is *always* interpreted as a hostname, and url
  // resolution will treat //foo/bar as host=foo,path=bar because that's
  // how the browser resolves relative URLs.
  if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
    var slashes = rest.substr(0, 2) === '//';
    if (slashes && !(proto && hostlessProtocol[proto])) {
      rest = rest.substr(2);
      this.slashes = true;
    }
  }

  if (!hostlessProtocol[proto] &&
      (slashes || (proto && !slashedProtocol[proto]))) {

    // there's a hostname.
    // the first instance of /, ?, ;, or # ends the host.
    //
    // If there is an @ in the hostname, then non-host chars *are* allowed
    // to the left of the last @ sign, unless some host-ending character
    // comes *before* the @-sign.
    // URLs are obnoxious.
    //
    // ex:
    // http://a@b@c/ => user:a@b host:c
    // http://a@b?@c => user:a host:c path:/?@c

    // v0.12 TODO(isaacs): This is not quite how Chrome does things.
    // Review our test case against browsers more comprehensively.

    // find the first instance of any hostEndingChars
    var hostEnd = -1;
    for (var i = 0; i < hostEndingChars.length; i++) {
      var hec = rest.indexOf(hostEndingChars[i]);
      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
        hostEnd = hec;
    }

    // at this point, either we have an explicit point where the
    // auth portion cannot go past, or the last @ char is the decider.
    var auth, atSign;
    if (hostEnd === -1) {
      // atSign can be anywhere.
      atSign = rest.lastIndexOf('@');
    } else {
      // atSign must be in auth portion.
      // http://a@b/c@d => host:b auth:a path:/c@d
      atSign = rest.lastIndexOf('@', hostEnd);
    }

    // Now we have a portion which is definitely the auth.
    // Pull that off.
    if (atSign !== -1) {
      auth = rest.slice(0, atSign);
      rest = rest.slice(atSign + 1);
      this.auth = decodeURIComponent(auth);
    }

    // the host is the remaining to the left of the first non-host char
    hostEnd = -1;
    for (var i = 0; i < nonHostChars.length; i++) {
      var hec = rest.indexOf(nonHostChars[i]);
      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
        hostEnd = hec;
    }
    // if we still have not hit it, then the entire thing is a host.
    if (hostEnd === -1)
      hostEnd = rest.length;

    this.host = rest.slice(0, hostEnd);
    rest = rest.slice(hostEnd);

    // pull out port.
    this.parseHost();

    // we've indicated that there is a hostname,
    // so even if it's empty, it has to be present.
    this.hostname = this.hostname || '';

    // if hostname begins with [ and ends with ]
    // assume that it's an IPv6 address.
    var ipv6Hostname = this.hostname[0] === '[' &&
        this.hostname[this.hostname.length - 1] === ']';

    // validate a little.
    if (!ipv6Hostname) {
      var hostparts = this.hostname.split(/\./);
      for (var i = 0, l = hostparts.length; i < l; i++) {
        var part = hostparts[i];
        if (!part) continue;
        if (!part.match(hostnamePartPattern)) {
          var newpart = '';
          for (var j = 0, k = part.length; j < k; j++) {
            if (part.charCodeAt(j) > 127) {
              // we replace non-ASCII char with a temporary placeholder
              // we need this to make sure size of hostname is not
              // broken by replacing non-ASCII by nothing
              newpart += 'x';
            } else {
              newpart += part[j];
            }
          }
          // we test again with ASCII char only
          if (!newpart.match(hostnamePartPattern)) {
            var validParts = hostparts.slice(0, i);
            var notHost = hostparts.slice(i + 1);
            var bit = part.match(hostnamePartStart);
            if (bit) {
              validParts.push(bit[1]);
              notHost.unshift(bit[2]);
            }
            if (notHost.length) {
              rest = '/' + notHost.join('.') + rest;
            }
            this.hostname = validParts.join('.');
            break;
          }
        }
      }
    }

    if (this.hostname.length > hostnameMaxLen) {
      this.hostname = '';
    } else {
      // hostnames are always lower case.
      this.hostname = this.hostname.toLowerCase();
    }

    if (!ipv6Hostname) {
      // IDNA Support: Returns a punycoded representation of "domain".
      // It only converts parts of the domain name that
      // have non-ASCII characters, i.e. it doesn't matter if
      // you call it with a domain that already is ASCII-only.
      this.hostname = punycode.toASCII(this.hostname);
    }

    var p = this.port ? ':' + this.port : '';
    var h = this.hostname || '';
    this.host = h + p;
    this.href += this.host;

    // strip [ and ] from the hostname
    // the host field still retains them, though
    if (ipv6Hostname) {
      this.hostname = this.hostname.substr(1, this.hostname.length - 2);
      if (rest[0] !== '/') {
        rest = '/' + rest;
      }
    }
  }

  // now rest is set to the post-host stuff.
  // chop off any delim chars.
  if (!unsafeProtocol[lowerProto]) {

    // First, make 100% sure that any "autoEscape" chars get
    // escaped, even if encodeURIComponent doesn't think they
    // need to be.
    for (var i = 0, l = autoEscape.length; i < l; i++) {
      var ae = autoEscape[i];
      if (rest.indexOf(ae) === -1)
        continue;
      var esc = encodeURIComponent(ae);
      if (esc === ae) {
        esc = escape(ae);
      }
      rest = rest.split(ae).join(esc);
    }
  }


  // chop off from the tail first.
  var hash = rest.indexOf('#');
  if (hash !== -1) {
    // got a fragment string.
    this.hash = rest.substr(hash);
    rest = rest.slice(0, hash);
  }
  var qm = rest.indexOf('?');
  if (qm !== -1) {
    this.search = rest.substr(qm);
    this.query = rest.substr(qm + 1);
    if (parseQueryString) {
      this.query = querystring.parse(this.query);
    }
    rest = rest.slice(0, qm);
  } else if (parseQueryString) {
    // no query string, but parseQueryString still requested
    this.search = '';
    this.query = {};
  }
  if (rest) this.pathname = rest;
  if (slashedProtocol[lowerProto] &&
      this.hostname && !this.pathname) {
    this.pathname = '/';
  }

  //to support http.request
  if (this.pathname || this.search) {
    var p = this.pathname || '';
    var s = this.search || '';
    this.path = p + s;
  }

  // finally, reconstruct the href based on what has been validated.
  this.href = this.format();
  return this;
};

// format a parsed object into a url string
function urlFormat(obj) {
  // ensure it's an object, and not a string url.
  // If it's an obj, this is a no-op.
  // this way, you can call url_format() on strings
  // to clean up potentially wonky urls.
  if (util.isString(obj)) obj = urlParse(obj);
  if (!(obj instanceof Url)) return Url.prototype.format.call(obj);
  return obj.format();
}

Url.prototype.format = function() {
  var auth = this.auth || '';
  if (auth) {
    auth = encodeURIComponent(auth);
    auth = auth.replace(/%3A/i, ':');
    auth += '@';
  }

  var protocol = this.protocol || '',
      pathname = this.pathname || '',
      hash = this.hash || '',
      host = false,
      query = '';

  if (this.host) {
    host = auth + this.host;
  } else if (this.hostname) {
    host = auth + (this.hostname.indexOf(':') === -1 ?
        this.hostname :
        '[' + this.hostname + ']');
    if (this.port) {
      host += ':' + this.port;
    }
  }

  if (this.query &&
      util.isObject(this.query) &&
      Object.keys(this.query).length) {
    query = querystring.stringify(this.query);
  }

  var search = this.search || (query && ('?' + query)) || '';

  if (protocol && protocol.substr(-1) !== ':') protocol += ':';

  // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
  // unless they had them to begin with.
  if (this.slashes ||
      (!protocol || slashedProtocol[protocol]) && host !== false) {
    host = '//' + (host || '');
    if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
  } else if (!host) {
    host = '';
  }

  if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
  if (search && search.charAt(0) !== '?') search = '?' + search;

  pathname = pathname.replace(/[?#]/g, function(match) {
    return encodeURIComponent(match);
  });
  search = search.replace('#', '%23');

  return protocol + host + pathname + search + hash;
};

function urlResolve(source, relative) {
  return urlParse(source, false, true).resolve(relative);
}

Url.prototype.resolve = function(relative) {
  return this.resolveObject(urlParse(relative, false, true)).format();
};

function urlResolveObject(source, relative) {
  if (!source) return relative;
  return urlParse(source, false, true).resolveObject(relative);
}

Url.prototype.resolveObject = function(relative) {
  if (util.isString(relative)) {
    var rel = new Url();
    rel.parse(relative, false, true);
    relative = rel;
  }

  var result = new Url();
  var tkeys = Object.keys(this);
  for (var tk = 0; tk < tkeys.length; tk++) {
    var tkey = tkeys[tk];
    result[tkey] = this[tkey];
  }

  // hash is always overridden, no matter what.
  // even href="" will remove it.
  result.hash = relative.hash;

  // if the relative url is empty, then there's nothing left to do here.
  if (relative.href === '') {
    result.href = result.format();
    return result;
  }

  // hrefs like //foo/bar always cut to the protocol.
  if (relative.slashes && !relative.protocol) {
    // take everything except the protocol from relative
    var rkeys = Object.keys(relative);
    for (var rk = 0; rk < rkeys.length; rk++) {
      var rkey = rkeys[rk];
      if (rkey !== 'protocol')
        result[rkey] = relative[rkey];
    }

    //urlParse appends trailing / to urls like http://www.example.com
    if (slashedProtocol[result.protocol] &&
        result.hostname && !result.pathname) {
      result.path = result.pathname = '/';
    }

    result.href = result.format();
    return result;
  }

  if (relative.protocol && relative.protocol !== result.protocol) {
    // if it's a known url protocol, then changing
    // the protocol does weird things
    // first, if it's not file:, then we MUST have a host,
    // and if there was a path
    // to begin with, then we MUST have a path.
    // if it is file:, then the host is dropped,
    // because that's known to be hostless.
    // anything else is assumed to be absolute.
    if (!slashedProtocol[relative.protocol]) {
      var keys = Object.keys(relative);
      for (var v = 0; v < keys.length; v++) {
        var k = keys[v];
        result[k] = relative[k];
      }
      result.href = result.format();
      return result;
    }

    result.protocol = relative.protocol;
    if (!relative.host && !hostlessProtocol[relative.protocol]) {
      var relPath = (relative.pathname || '').split('/');
      while (relPath.length && !(relative.host = relPath.shift()));
      if (!relative.host) relative.host = '';
      if (!relative.hostname) relative.hostname = '';
      if (relPath[0] !== '') relPath.unshift('');
      if (relPath.length < 2) relPath.unshift('');
      result.pathname = relPath.join('/');
    } else {
      result.pathname = relative.pathname;
    }
    result.search = relative.search;
    result.query = relative.query;
    result.host = relative.host || '';
    result.auth = relative.auth;
    result.hostname = relative.hostname || relative.host;
    result.port = relative.port;
    // to support http.request
    if (result.pathname || result.search) {
      var p = result.pathname || '';
      var s = result.search || '';
      result.path = p + s;
    }
    result.slashes = result.slashes || relative.slashes;
    result.href = result.format();
    return result;
  }

  var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
      isRelAbs = (
          relative.host ||
          relative.pathname && relative.pathname.charAt(0) === '/'
      ),
      mustEndAbs = (isRelAbs || isSourceAbs ||
                    (result.host && relative.pathname)),
      removeAllDots = mustEndAbs,
      srcPath = result.pathname && result.pathname.split('/') || [],
      relPath = relative.pathname && relative.pathname.split('/') || [],
      psychotic = result.protocol && !slashedProtocol[result.protocol];

  // if the url is a non-slashed url, then relative
  // links like ../.. should be able
  // to crawl up to the hostname, as well.  This is strange.
  // result.protocol has already been set by now.
  // Later on, put the first path part into the host field.
  if (psychotic) {
    result.hostname = '';
    result.port = null;
    if (result.host) {
      if (srcPath[0] === '') srcPath[0] = result.host;
      else srcPath.unshift(result.host);
    }
    result.host = '';
    if (relative.protocol) {
      relative.hostname = null;
      relative.port = null;
      if (relative.host) {
        if (relPath[0] === '') relPath[0] = relative.host;
        else relPath.unshift(relative.host);
      }
      relative.host = null;
    }
    mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
  }

  if (isRelAbs) {
    // it's absolute.
    result.host = (relative.host || relative.host === '') ?
                  relative.host : result.host;
    result.hostname = (relative.hostname || relative.hostname === '') ?
                      relative.hostname : result.hostname;
    result.search = relative.search;
    result.query = relative.query;
    srcPath = relPath;
    // fall through to the dot-handling below.
  } else if (relPath.length) {
    // it's relative
    // throw away the existing file, and take the new path instead.
    if (!srcPath) srcPath = [];
    srcPath.pop();
    srcPath = srcPath.concat(relPath);
    result.search = relative.search;
    result.query = relative.query;
  } else if (!util.isNullOrUndefined(relative.search)) {
    // just pull out the search.
    // like href='?foo'.
    // Put this after the other two cases because it simplifies the booleans
    if (psychotic) {
      result.hostname = result.host = srcPath.shift();
      //occationaly the auth can get stuck only in host
      //this especially happens in cases like
      //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
      var authInHost = result.host && result.host.indexOf('@') > 0 ?
                       result.host.split('@') : false;
      if (authInHost) {
        result.auth = authInHost.shift();
        result.host = result.hostname = authInHost.shift();
      }
    }
    result.search = relative.search;
    result.query = relative.query;
    //to support http.request
    if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
      result.path = (result.pathname ? result.pathname : '') +
                    (result.search ? result.search : '');
    }
    result.href = result.format();
    return result;
  }

  if (!srcPath.length) {
    // no path at all.  easy.
    // we've already handled the other stuff above.
    result.pathname = null;
    //to support http.request
    if (result.search) {
      result.path = '/' + result.search;
    } else {
      result.path = null;
    }
    result.href = result.format();
    return result;
  }

  // if a url ENDs in . or .., then it must get a trailing slash.
  // however, if it ends in anything else non-slashy,
  // then it must NOT get a trailing slash.
  var last = srcPath.slice(-1)[0];
  var hasTrailingSlash = (
      (result.host || relative.host || srcPath.length > 1) &&
      (last === '.' || last === '..') || last === '');

  // strip single dots, resolve double dots to parent dir
  // if the path tries to go above the root, `up` ends up > 0
  var up = 0;
  for (var i = srcPath.length; i >= 0; i--) {
    last = srcPath[i];
    if (last === '.') {
      srcPath.splice(i, 1);
    } else if (last === '..') {
      srcPath.splice(i, 1);
      up++;
    } else if (up) {
      srcPath.splice(i, 1);
      up--;
    }
  }

  // if the path is allowed to go above the root, restore leading ..s
  if (!mustEndAbs && !removeAllDots) {
    for (; up--; up) {
      srcPath.unshift('..');
    }
  }

  if (mustEndAbs && srcPath[0] !== '' &&
      (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
    srcPath.unshift('');
  }

  if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
    srcPath.push('');
  }

  var isAbsolute = srcPath[0] === '' ||
      (srcPath[0] && srcPath[0].charAt(0) === '/');

  // put the host back
  if (psychotic) {
    result.hostname = result.host = isAbsolute ? '' :
                                    srcPath.length ? srcPath.shift() : '';
    //occationaly the auth can get stuck only in host
    //this especially happens in cases like
    //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
    var authInHost = result.host && result.host.indexOf('@') > 0 ?
                     result.host.split('@') : false;
    if (authInHost) {
      result.auth = authInHost.shift();
      result.host = result.hostname = authInHost.shift();
    }
  }

  mustEndAbs = mustEndAbs || (result.host && srcPath.length);

  if (mustEndAbs && !isAbsolute) {
    srcPath.unshift('');
  }

  if (!srcPath.length) {
    result.pathname = null;
    result.path = null;
  } else {
    result.pathname = srcPath.join('/');
  }

  //to support request.http
  if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
    result.path = (result.pathname ? result.pathname : '') +
                  (result.search ? result.search : '');
  }
  result.auth = relative.auth || result.auth;
  result.slashes = result.slashes || relative.slashes;
  result.href = result.format();
  return result;
};

Url.prototype.parseHost = function() {
  var host = this.host;
  var port = portPattern.exec(host);
  if (port) {
    port = port[0];
    if (port !== ':') {
      this.port = port.substr(1);
    }
    host = host.substr(0, host.length - port.length);
  }
  if (host) this.hostname = host;
};

const { URL } = url;

const URL_PATTERNS = new RegExp(/^\/?:?([/\w-.]+)\/([\w-.]+)\/?$/);
const GITHUB_API = new RegExp(/^\/repos\/([\w-.]+)\/([\w-.]+)\/(?:tarball|zipball)(?:\/.+)?$/);
const GITHUB_CODELOAD = new RegExp(/^\/([\w-.]+)\/([\w-.]+)\/(?:legacy\.(?:zip|tar\.gz))(?:\/.+)?$/);

var src = url => {
  const modifiedURL = url
    // Prepend `https` to the URL so that `url.URL` will see the value of `url` as an actual `url`, and therefore, correctly parse it.
    .replace(/^git@/, 'https://git@')

    // Replace `:` with `/` before path segments so that `url.URL` will see the value of `url` as an actual `url`, and therefore, correctly parse it.
    .replace(/git@([.\w]+):(?!\d)/, 'git@$1/')

    // Remove `.git` from any URL before applying regular expressions to the string. Removing `.git` through a non capture group is kind of difficult.
    .replace(/\.git$/, '');

  const parsedURL = new URL(modifiedURL, 'https://example.com/');
  const format = matches => {
    return { browse: createBrowseURL(parsedURL, matches), domain: parsedURL.host, project: matches[2] || null, type: getType(parsedURL), user: matches[1] || null };
  };

  if (parsedURL.host) {
    if (parsedURL.host.includes('api.github.com')) {
      const matches = GITHUB_API.exec(parsedURL.pathname) || [];
      return format(matches);
    }

    if (parsedURL.host.includes('codeload.github.com')) {
      const matches = GITHUB_CODELOAD.exec(parsedURL.pathname) || [];
      return format(matches);
    }
  }

  return format(URL_PATTERNS.exec(parsedURL.pathname) || []);
};

function getType ({ host }) {
  if (typeof host !== 'string') {
    return null;
  }

  if (host.indexOf('github') !== -1) {
    return 'github';
  }
  if (host.indexOf('gitlab') !== -1) {
    return 'gitlab';
  }

  return null;
}

function createBrowseURL (parsedURL, matches) {
  const protocol = parsedURL.protocol === 'http:' ? 'http:' : 'https:';
  const browseURL = `${protocol}//${parsedURL.host}/${matches[1]}/${matches[2]}`;

  return () => {
    return browseURL;
  };
}

const traverseFolder = (filePath, levels = 10, fileName = 'package.json') => {
    if (!fs__namespace.existsSync(filePath)) {
        return null;
    }
    const files = fs__namespace.readdirSync(filePath);
    if (levels === 0) {
        return null;
    }
    const pckg = files.find((file) => file === fileName);
    if (pckg) {
        return path.resolve(filePath, pckg);
    }
    return traverseFolder(path.resolve(filePath, '..'), levels - 1, fileName);
};
/**
 * Retrieves the repo path from the project's package.json file.
 * @param filePath file path to start the search for a package.json
 */
const getRepoPath = (filePath) => {
    const packageFileName = traverseFolder(path.dirname(filePath));
    const result = {};
    if (packageFileName) {
        const packageJSON = JSON.parse(fs__namespace.readFileSync(packageFileName, 'utf8'));
        result.packageName = packageJSON.name;
        result.relativePath = path.relative(path.dirname(packageFileName), filePath);
        const repositoryURL = typeof packageJSON.repository === 'string'
            ? packageJSON.repository
            : packageJSON.repository && packageJSON.repository.url;
        if (repositoryURL) {
            const templates = hostedGitInfo__default["default"].fromUrl(repositoryURL) ||
                src(repositoryURL);
            result.relativePath = `${packageJSON.repository && packageJSON.repository.directory
                ? `${packageJSON.repository.directory}/`
                : ''}${path.relative(path.dirname(packageFileName), filePath)}`;
            const fillTemplate = (template) => {
                return template
                    .replace('auth@', templates.auth || '')
                    .replace('{domain}', templates.domain || '')
                    .replace('{user}', templates.user || '')
                    .replace('{project}', templates.project || '')
                    .replace('{#fragment}', '')
                    .replace('{path}', result.relativePath)
                    .replace('{treepath}', templates.treepath || '')
                    .replace('{/tree/committish}', `/${templates.treepath}/${templates.committish || 'master'}`)
                    .replace('{committish}', templates.committish || 'master');
            };
            result.repo = fillTemplate(templates.browsefiletemplate);
        }
    }
    return result;
};

const textNode = (value) => ({ kind: exports.NodeKind.Text, value });

const boldNode = (value) => ({
    kind: exports.NodeKind.Bold,
    children: typeof value === 'string' ? [textNode(value)] : value,
});

const tableCellNode = (value) => ({
    kind: exports.NodeKind.TableCell,
    children: typeof value === 'string' ? [textNode(value)] : value,
});

const inlineCodeNode = (value) => ({
    kind: exports.NodeKind.InlineCode,
    value,
});

const createPropsRow = ({ name, type, value, parent, description }, visColumns) => {
    const children = [
        tableCellNode(name || []),
        tableCellNode(type || []),
    ];
    if (visColumns.parents) {
        children.push(tableCellNode(parent || []));
    }
    if (visColumns.values) {
        children.push(tableCellNode([
            inlineCodeNode(typeof value !== 'undefined' ? value.toString() : ''),
        ]));
    }
    if (visColumns.descriptions) {
        if (description) {
            const parts = description.split('`');
            if (parts.length > 1) {
                children.push(tableCellNode(parts.reduce((acc, text, idx) => {
                    if (idx % 2 === 0) {
                        return [...acc, textNode(text)];
                    }
                    else {
                        return [
                            ...acc,
                            textNode(' '),
                            inlineCodeNode(text),
                            textNode(' '),
                        ];
                    }
                }, [])));
            }
            else {
                children.push(tableCellNode([textNode(description)]));
            }
        }
        else {
            children.push(tableCellNode([textNode('')]));
        }
    }
    return {
        kind: exports.NodeKind.TableRow,
        children,
    };
};
const createPropsTable = (children, title) => {
    var _a;
    const propsTable = [];
    let table = undefined;
    const visibleColumns = {};
    if (children) {
        if (title) {
            propsTable.push(boldNode([textNode(title)]));
        }
        const columns = [];
        visibleColumns.names = children.some((item) => item.name !== undefined);
        if (visibleColumns.names) {
            columns.push(tableCellNode([textNode('Name')]));
        }
        visibleColumns.types = children.some((item) => item.type !== undefined);
        if (visibleColumns.types) {
            columns.push(tableCellNode([textNode('Type')]));
        }
        visibleColumns.parents = children.some((item) => item.parent !== undefined);
        if (visibleColumns.parents) {
            columns.push(tableCellNode([textNode('Parent')]));
        }
        visibleColumns.values = children.some((item) => item.value !== undefined);
        if (visibleColumns.values) {
            columns.push(tableCellNode([textNode('Value')]));
        }
        visibleColumns.descriptions = children.some((item) => item.description);
        if (visibleColumns.descriptions) {
            columns.push(tableCellNode([textNode('Description')]));
        }
        table = {
            kind: exports.NodeKind.Table,
            children: [
                {
                    kind: exports.NodeKind.TableRow,
                    children: columns,
                },
            ],
        };
        propsTable.push(table);
        // eslint-disable-next-line prefer-spread
        (_a = table.children) === null || _a === void 0 ? void 0 : _a.push(...children.map((child) => createPropsRow(child, visibleColumns)));
    }
    return { propsTable, table, visibleColumns };
};

const paragraphNode = (value) => ({
    kind: exports.NodeKind.Paragraph,
    children: typeof value === 'string' ? [textNode(value)] : value,
});

const emphasisNode = (value) => ({
    kind: exports.NodeKind.Emphasis,
    children: typeof value === 'string' ? [textNode(value)] : value,
});

const codeNode = (value) => ({
    kind: exports.NodeKind.Code,
    value,
});

const linkNode = (children, url, loc) => {
    const prop = {
        kind: exports.NodeKind.Link,
        children,
    };
    if (url) {
        prop.url = url;
    }
    if (loc) {
        prop.loc = loc;
    }
    return prop;
};

/* eslint-disable prefer-spread */
class PropsToDocumentation {
    constructor() {
        this.collapsed = [];
        this.sections = ['all'];
        this.columns = ['all'];
        this.skipInherited = false;
        this.topLevelProps = {};
        this.helpers = {};
        this.repoNames = {};
        this.getPropLink = (key) => {
            const nameParts = key.split('.');
            return this.topLevelProps[nameParts[nameParts.length - 1]];
        };
    }
    extractPropTable(props, title) {
        let parentProp = undefined;
        const addParentProp = (prop) => {
            var _a, _b;
            if (prop.parent) {
                if (!parentProp) {
                    parentProp = {
                        name: '...props',
                        kind: api.PropKind.Enum,
                        properties: [
                            {
                                kind: api.PropKind.Type,
                                type: prop.parent.name,
                                loc: prop.parent.loc,
                            },
                        ],
                        optional: true,
                    };
                }
                else {
                    if (!((_a = parentProp.properties) === null || _a === void 0 ? void 0 : _a.find((p) => { var _a; return p.type === ((_a = prop.parent) === null || _a === void 0 ? void 0 : _a.name); }))) {
                        (_b = parentProp.properties) === null || _b === void 0 ? void 0 : _b.push({
                            kind: api.PropKind.Type,
                            type: prop.parent.name,
                            loc: prop.parent.loc,
                        });
                    }
                }
            }
        };
        const consolidatedProps = props.filter((prop) => {
            var _a;
            if (prop.parent) {
                if (this.skipInherited || this.collapsed.includes(prop.parent.name)) {
                    addParentProp(prop);
                    return false;
                }
                for (const collapsedProp of this.collapsed) {
                    const helperParent = this.helpers[collapsedProp];
                    if (helperParent && api.hasProperties(helperParent)) {
                        const helpProp = (_a = helperParent.properties) === null || _a === void 0 ? void 0 : _a.find((p) => { var _a, _b; return p.name === prop.name && ((_a = p.parent) === null || _a === void 0 ? void 0 : _a.name) === ((_b = prop.parent) === null || _b === void 0 ? void 0 : _b.name); });
                        if (helpProp) {
                            addParentProp({
                                ...prop,
                                parent: { name: collapsedProp, loc: helperParent.loc },
                            });
                            return false;
                        }
                    }
                }
            }
            return true;
        });
        const allProps = parentProp
            ? [...consolidatedProps, parentProp]
            : consolidatedProps;
        const items = allProps.map((prop) => {
            let name = prop.name
                ? prop.kind === api.PropKind.Rest
                    ? `...${prop.name}`
                    : prop.name
                : '';
            name = `${name}${prop.optional ? '' : '*'}`;
            return this.configurePropItem({
                name: prop.loc
                    ? this.propLink({ name, loc: prop.loc })
                    : [inlineCodeNode(name)],
                parent: prop.parent ? this.propLink(prop.parent) : undefined,
                type: this.extractPropType(prop, { extractProperties: true }),
                description: prop.description,
                value: prop.value,
            });
        });
        return createPropsTable(items, title);
    }
    extractFunctionDeclaration(prop) {
        const result = [textNode('(')];
        if (prop.parameters) {
            for (let i = 0; i < prop.parameters.length; i += 1) {
                const p = prop.parameters[i];
                if (i > 0) {
                    result.push(textNode(', '));
                }
                if (p.name) {
                    result.push(inlineCodeNode(p.name));
                    if (!p.optional) {
                        result.push(textNode('*'));
                    }
                    result.push(textNode(': '));
                }
                result.push(...this.extractPropType(p));
                if (!p.name && !p.optional) {
                    result.push(textNode('*'));
                }
            }
        }
        result.push(textNode(')'));
        result.push(textNode(' => '));
        if (prop.returns) {
            result.push(...this.extractPropType(prop.returns));
        }
        else {
            result.push(textNode('void'));
        }
        return result;
    }
    configurePropItem(item) {
        const enabledColumn = (name) => {
            return this.columns.includes(name) || this.columns.includes('all');
        };
        return {
            name: enabledColumn('name') ? item.name : undefined,
            parent: enabledColumn('parents') ? item.parent : undefined,
            type: enabledColumn('type') ? item.type : undefined,
            value: enabledColumn('value') ? item.value : undefined,
            description: enabledColumn('description') ? item.description : undefined,
        };
    }
    extractFunction(prop, _extractTable = true) {
        if (prop.parameters) {
            const { propsTable, table, visibleColumns } = this.extractPropTable(prop.parameters, 'parameters');
            if (table &&
                table.children &&
                prop.returns &&
                prop.returns.kind !== api.PropKind.Void) {
                table.children.push(createPropsRow(this.configurePropItem({
                    name: [inlineCodeNode('returns')],
                    parent: prop.returns.parent
                        ? this.propLink(prop.returns.parent)
                        : undefined,
                    type: this.extractPropType(prop.returns),
                    description: prop.returns.description,
                }), visibleColumns));
            }
            return propsTable;
        }
        return [];
    }
    extractInterface(prop) {
        var _a;
        const result = [];
        if (prop.name) {
            if ((_a = prop.extends) === null || _a === void 0 ? void 0 : _a.length) {
                const extendsList = prop.extends.reduce((acc, key, idx) => {
                    const p = this.getPropLink(key);
                    let result;
                    if (p) {
                        result = this.extractPropType(p);
                    }
                    else {
                        result = [textNode(key)];
                    }
                    if (prop.extends && idx < prop.extends.length - 1) {
                        result.push(textNode(', '));
                    }
                    return [...acc, ...result];
                }, []);
                result.push(paragraphNode([textNode('extends '), ...extendsList]));
            }
            if (api.isUnionProp(prop)) {
                result.push(...this.extractPropType(prop));
            }
            else if (api.hasProperties(prop) && prop.properties) {
                const { propsTable } = this.extractPropTable(prop.properties, 'properties');
                result.push(...propsTable);
            }
        }
        return result;
    }
    propLink(prop) {
        var _a;
        const typeText = [inlineCodeNode(prop.name)];
        if (typeof prop.name === 'string') {
            const link = this.getPropLink(prop.name);
            return [
                linkNode(typeText, link ? `#${(_a = link.name) === null || _a === void 0 ? void 0 : _a.toLowerCase()}` : undefined, prop.loc),
            ];
        }
        return typeText;
    }
    inlineType(prop) {
        let typeNode = undefined;
        if (typeof prop.type === 'string') {
            typeNode = this.propLink({ name: prop.type, loc: prop.loc });
        }
        else if (prop.kind) {
            typeNode = [inlineCodeNode(`${api.PropKind[prop.kind].toLowerCase()}`)];
        }
        if (prop.name && prop.name !== prop.type) {
            return [
                inlineCodeNode(`${prop.name}`),
                textNode(`${typeNode ? ': ' : ''}`),
                ...(typeNode || []),
            ];
        }
        return typeNode || [];
    }
    typeNode(prop, showValue = true) {
        if (typeof prop.type === 'string') {
            if (typeof prop.parent === 'string') {
                return [...this.propLink(prop.parent), textNode(`.${prop.type}`)];
            }
            return this.propLink({ name: prop.type, loc: prop.loc });
        }
        if (showValue && prop.value !== undefined) {
            const value = api.isStringProp(prop)
                ? `"${jsStringEscape__default["default"](prop.value)}"`
                : prop.value.toString();
            return [textNode(value)];
        }
        if (prop.kind) {
            const typeNode = [
                inlineCodeNode(`${api.PropKind[prop.kind].toLowerCase()}`),
            ];
            if (typeof prop.parent === 'string' && this.getPropLink(prop.parent)) {
                const link = this.propLink(prop.parent);
                if (link.length) {
                    typeNode.push(textNode(` (`));
                    typeNode.push(...link);
                    typeNode.push(textNode(`)`));
                }
            }
            return typeNode;
        }
        if (prop.name) {
            return [textNode(prop.name)];
        }
        return [];
    }
    extractPropType(prop, options) {
        var _a;
        if (prop.parent) {
            const parent = this.getPropLink(prop.parent.name);
            if (parent && api.isClassLikeProp(parent)) {
                const p = (_a = parent.properties) === null || _a === void 0 ? void 0 : _a.find((p) => p.name === prop.name);
                if (p) {
                    return this.extractType(p, options);
                }
            }
        }
        return this.extractType(prop, options);
    }
    extractType(prop, options) {
        var _a, _b, _c, _d, _e;
        const { showValue = false } = options || {};
        if (typeof prop.type === 'string' && ((_a = this.collapsed) === null || _a === void 0 ? void 0 : _a.includes(prop.type))) {
            return this.typeNode(prop, showValue);
        }
        else if ((api.isUnionProp(prop) || api.isEnumProp(prop)) && prop.properties) {
            const separator = api.isUnionProp(prop) ? ' | ' : ' & ';
            return (_b = prop.properties) === null || _b === void 0 ? void 0 : _b.reduce((acc, t, idx) => {
                const r = [...acc, ...this.extractPropType(t, { showValue: true })];
                if (prop.properties && idx < prop.properties.length - 1) {
                    r.push(textNode(separator));
                }
                return r;
            }, []);
        }
        else if (api.isClassLikeProp(prop)) {
            const propName = typeof prop.type === 'string' ? prop.type : prop.name;
            const result = [];
            if (typeof propName === 'string' && this.getPropLink(propName)) {
                result.push(...this.propLink({ name: propName, loc: prop.loc }));
            }
            else if ((_c = prop.properties) === null || _c === void 0 ? void 0 : _c.length) {
                const typeArguments = prop.properties.reduce((acc, p, idx) => {
                    const result = [...acc, ...this.inlineType(p)];
                    if (prop.properties && idx < prop.properties.length - 1) {
                        result.push(textNode(', '));
                    }
                    return result;
                }, []);
                result.push(textNode('{ '));
                result.push(...typeArguments);
                result.push(textNode(' }'));
            }
            else if ((_d = prop.generics) === null || _d === void 0 ? void 0 : _d.length) {
                const genericArguments = (_e = prop.generics) === null || _e === void 0 ? void 0 : _e.reduce((acc, p, idx) => {
                    const result = [...acc, ...this.inlineType(p)];
                    if (prop.generics && idx < prop.generics.length - 1) {
                        result.push(textNode(', '));
                    }
                    return result;
                }, []);
                result.push(...this.typeNode(prop));
                if (genericArguments === null || genericArguments === void 0 ? void 0 : genericArguments.length) {
                    result.push(...[textNode('<'), ...genericArguments, textNode('>')]);
                }
            }
            else if (propName) {
                result.push(textNode(propName));
            }
            return result;
        }
        else if (api.isArrayProp(prop) && prop.properties) {
            const elements = prop.properties.reduce((acc, p, idx) => {
                const result = this.extractPropType(p);
                if (prop.properties && idx < prop.properties.length - 1) {
                    result.push(textNode(', '));
                }
                return [...acc, ...result];
            }, []);
            const multiProps = elements.length &&
                elements[0].children &&
                elements[0].children.length > 1;
            if (multiProps) {
                elements.splice(0, 0, textNode('('));
                elements.push(textNode(')'));
            }
            elements.push(textNode('[]'));
            return elements;
        }
        else if (api.isTupleProp(prop) && prop.properties) {
            return [
                textNode('['),
                ...prop.properties.reduce((acc, p, idx) => {
                    const result = this.extractPropType(p);
                    if (prop.properties && idx < prop.properties.length - 1) {
                        result.push(textNode(', '));
                    }
                    return [...acc, ...result];
                }, []),
                { kind: exports.NodeKind.Text, value: ']' },
            ];
        }
        else if (api.isIndexProp(prop)) {
            const results = [
                textNode('['),
                ...this.extractPropType(prop.index),
                textNode(']'),
            ];
            if (prop.prop) {
                results.push(textNode(': '));
                results.push(...this.extractPropType(prop.prop));
            }
            return results;
            //return this.extractFunctionDeclaration(prop);
        }
        else if (api.isFunctionProp(prop)) {
            return this.extractFunctionDeclaration(prop);
        }
        return this.typeNode(prop, showValue);
    }
    getSourceLocation(prop) {
        const { filePath, loc } = prop.loc || {};
        if (filePath) {
            if (!this.repoNames[filePath]) {
                this.repoNames[filePath] = getRepoPath(path.resolve(filePath));
            }
            if (this.repoNames[filePath]) {
                const { repo, relativePath, packageName } = this.repoNames[filePath];
                const fileLocation = repo || filePath;
                if (fileLocation) {
                    const { line } = (loc === null || loc === void 0 ? void 0 : loc.start) || {};
                    const sourceLocation = filePath.includes('node_modules')
                        ? fileLocation
                        : `${fileLocation}${line ? `#L${line}` : ''}`;
                    return [
                        paragraphNode([
                            emphasisNode([
                                textNode('defined in '),
                                linkNode([
                                    textNode(packageName
                                        ? `${packageName}/${relativePath}`
                                        : sourceLocation),
                                ], sourceLocation, prop.loc),
                            ]),
                        ]),
                    ];
                }
            }
        }
        return [];
    }
    extractPropDefinition(prop) {
        const definition = {
            kind: exports.NodeKind.Paragraph,
            children: [],
        };
        if (prop.kind) {
            definition.children.push(boldNode([
                inlineCodeNode(`${prop.extension ? `${prop.extension} ` : ''}${api.PropKind[prop.kind].toLowerCase()}`),
            ]));
        }
        else if (typeof prop.type === 'string') {
            definition.children.push(boldNode(this.propLink({ name: prop.type, loc: prop.loc })));
        }
        const loc = this.getSourceLocation(prop);
        if (loc.length) {
            definition.children.push(textNode(' '));
            definition.children.push(...loc);
        }
        return definition;
    }
    generateSection(section) {
        return this.sections.includes(section) || this.sections.includes('all');
    }
    extractTSType(prop) {
        const result = [];
        if (this.generateSection('title') && prop.name) {
            result.push({
                kind: exports.NodeKind.Heading,
                depth: 2,
                children: [textNode(prop.name)],
            });
        }
        if (this.generateSection('location')) {
            result.push(this.extractPropDefinition(prop));
        }
        if (prop.description && this.generateSection('description')) {
            result.push(...prop.description.split('\n').map((d) => ({
                kind: exports.NodeKind.Paragraph,
                children: [
                    {
                        kind: exports.NodeKind.Text,
                        value: d,
                    },
                ],
            })));
        }
        if (this.generateSection('props')) {
            if (api.isFunctionProp(prop)) {
                result.push(...this.extractFunction(prop));
            }
            else if (api.hasProperties(prop)) {
                result.push(...this.extractInterface(prop));
            }
        }
        if (prop.examples && this.generateSection('examples')) {
            const codeExamples = prop.examples.filter((e) => e.content);
            result.push(paragraphNode([
                boldNode(`example${codeExamples.length > 1 ? 's' : ''}`),
            ]));
            codeExamples.forEach((example) => {
                if (example.content) {
                    result.push(codeNode(example.content));
                }
            });
        }
        return result;
    }
    extract(props, options = {}) {
        const result = [];
        const { collapsed = [], extensions, visible, sections = ['all'], columns = ['all'], skipInherited = false, overrides = {}, } = options;
        this.collapsed = collapsed;
        this.sections = sections;
        this.columns = columns;
        this.skipInherited = skipInherited;
        const filterProps = (prop) => {
            const transform = (p) => {
                var _a;
                if (p.name && overrides[p.name] && api.hasProperties(p)) {
                    const o = overrides[p.name];
                    return {
                        ...p,
                        properties: (_a = p.properties) === null || _a === void 0 ? void 0 : _a.map((pp) => pp.name && o[pp.name] ? { ...pp, ...o[pp.name] } : pp),
                    };
                }
                return p;
            };
            if (Array.isArray(extensions)) {
                if (typeof prop.extension === 'string' &&
                    extensions.includes(prop.extension)) {
                    return transform(prop);
                }
                return undefined;
            }
            if (Array.isArray(visible)) {
                if (typeof prop.name === 'string' && visible.includes(prop.name)) {
                    return transform(prop);
                }
                return undefined;
            }
            return transform(prop);
        };
        Object.keys(props).forEach((key) => {
            if (key !== '__helpers' && key !== '__diagnostics') {
                const prop = filterProps(props[key]);
                if (prop) {
                    this.topLevelProps[key] = prop;
                }
            }
        });
        this.helpers = props.__helpers || {};
        Object.keys(this.helpers).forEach((key) => {
            const prop = filterProps(this.helpers[key]);
            if (prop) {
                this.topLevelProps[key] = prop;
            }
        });
        Object.values(this.topLevelProps).forEach((prop) => {
            const nodes = this.extractTSType(prop);
            result.push(...nodes);
        });
        return result;
    }
}

/**
 * Creates a list of api documentation nodes
 * @param props properties parsed from `structured-types/api`
 * @param options page generation options
 * @returns a list of documentation nodes
 */
const propsToDocumentation = (props, options) => {
    const extractor = new PropsToDocumentation();
    return extractor.extract(props, options);
};
/**
 * Read the api-docs configuration file
 * @param fileName the file that is being analyzed, will be used the starting folder to search for configuration files.
 * @param configFileName pass directly the configuration file name
 * @returns page generation options from the config file
 */
const apiDocsConfig = (fileName, configFileName) => {
    const configExplorer = cosmiconfig.cosmiconfigSync('api-docs');
    if (configFileName) {
        return configExplorer.load(configFileName);
    }
    const searchPath = path$1.exports.dirname(fileName);
    return configExplorer.search(searchPath);
};

exports.apiDocsConfig = apiDocsConfig;
exports.getRepoPath = getRepoPath;
exports.isBoldNode = isBoldNode;
exports.isCodeNode = isCodeNode;
exports.isEmphasisNode = isEmphasisNode;
exports.isHeadingNode = isHeadingNode;
exports.isInlineCodeNode = isInlineCodeNode;
exports.isLinkNode = isLinkNode;
exports.isNodeWithChildren = isNodeWithChildren;
exports.isNodeWithValue = isNodeWithValue;
exports.isParagraphNode = isParagraphNode;
exports.isTableCellNode = isTableCellNode;
exports.isTableNode = isTableNode;
exports.isTableRowNode = isTableRowNode;
exports.isTextNode = isTextNode;
exports.propsToDocumentation = propsToDocumentation;
